#include "chdecl.h"
void CH_cat(current, sched, cop)
#define ARGUMENTS 6
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb1;
    case 2: goto c2;
    case 3: goto cb4;
    case 4: goto c5;
    case 5: goto cb8;
    case 6: goto c9;
    case 7: goto c12;
    case 8: goto cb24;
    case 9: goto c25;
    case 13: goto c26;
    case 10: goto c26;
    case 11: goto cb29;
    case 12: goto c30;
    case 14: goto c32;
    case 15: goto c35;
    case 16: goto cb38;
    case 17: goto c39;
    case 21: goto c41;
    case 18: goto c41;
    case 19: goto cb45;
    case 20: goto c46;
    case 22: goto c48;
    case 23: goto cb50;
    case 24: goto c51;
    case 25: goto c53;
    case 26: goto c54;
    case 27: goto c59;
    case 28: goto c64;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb1:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c2:
/* chs_lit 4 , "stdio" */
  if( !chs_lit(DEF(4),"stdio") ) goto ch_depletion;
/* chs_lit 5 , "" */
  if( !chs_lit(DEF(5),"") ) goto ch_depletion;
  current->ip = 3;
cb4:
/* call 3.2.2 4 5 6 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(2),
          arguments[1] = DEF(4),
          arguments[2] = DEF(5),
          arguments[3] = DEF(6),
          arguments[3+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c5:
/* unwrap 7 6 , 2 */
  if ((ch_returncode = che_unwrap(DEF(7),DEF(6),QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
/* chs_lit 8 , "stdout" */
  if( !chs_lit(DEF(8),"stdout") ) goto ch_depletion;
/* chs_lit 9 , "stdio" */
  if( !chs_lit(DEF(9),"stdio") ) goto ch_depletion;
  current->ip = 5;
cb8:
/* call 3.2.2 8 9 10 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(2),
          arguments[1] = DEF(8),
          arguments[2] = DEF(9),
          arguments[3] = DEF(10),
          arguments[3+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c9:
/* unwrap 11 10 , 3 */
  if ((ch_returncode = che_unwrap(DEF(11),DEF(10),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
/* copy 12 3.0 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(0).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(12).tsdr)->finalize)(REF(12).value,F_DISCARD,sched);
  REF(12).value = ch_val;
  REF(12).tsdr = & dr_table;
/* initget 13 12 , 0,0 */
  (*(REF(13).tsdr)->finalize)(REF(13).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(13),DEF(12),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c12:
/* get_or_goto 13 12 , 59 */
  if ((ch_returncode = get_selected_object(DEF(13),DEF(12),sched)) != Normal)
     goto c59;
/* position 14 13 */
  ch_frame = get_selector_frame(DEF(13),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(14).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(14).tsdr = &dr_integer;
/* ilt . 14 =(2) , 12 */
  if ( REF(14).value.integer < 2 ) goto c12;
/* chs_lit 15 , "-" */
  if( !chs_lit(DEF(15),"-") ) goto ch_depletion;
/* equal 16 13 15 */
  REF(16).value.boolean = (eq_table(REF(13).value,REF(15).value));
  REF(16).tsdr = & dr_boolean;
/* discard 15 */
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  REF(15).tsdr = & dr_bottom;
/* branch_false 16 , 35 */
  if ( !REF(16).value.boolean ) goto c35;
/* block , 4 */
  if((ch_returncode = che_block(QUAL(4),sched)) != Normal)
     goto ch_raise_exception;
/* chs_lit 17 , "stdin" */
  if( !chs_lit(DEF(17),"stdin") ) goto ch_depletion;
/* chs_lit 18 , "stdio" */
  if( !chs_lit(DEF(18),"stdio") ) goto ch_depletion;
  current->ip = 8;
cb24:
/* call 3.2.2 17 18 19 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(2),
          arguments[1] = DEF(17),
          arguments[2] = DEF(18),
          arguments[3] = DEF(19),
          arguments[3+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c25:
/* unwrap 20 19 , 5 */
  if ((ch_returncode = che_unwrap(DEF(20),DEF(19),QUAL(5),sched)) != Normal)
     goto ch_raise_exception;
c31:
c26:
/* discard 21 */
  (*(REF(21).tsdr)->finalize)(REF(21).value,F_DISCARD,sched);
  REF(21).tsdr = & dr_bottom;
  current->ip = 11;
cb29:
/* call 20.1 21 , 6 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(20)DOT(1),
          arguments[1] = DEF(21),
          arguments[1+1] = nil,& arguments[0]),QUAL(6),sched)) != Normal)
     goto ch_raise_exception;
  return;
c30:
/* call 11.2 21 , 7 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(11)DOT(2),
          arguments[1] = DEF(21),
          arguments[1+1] = nil,& arguments[0]),QUAL(7),sched)) != Normal)
     goto ch_raise_exception;
  return;
c32:
/* endblock */
  che_endblock(sched);
/* branch , 54 */
   goto c54;
c35:
/* block , 8 */
  if((ch_returncode = che_block(QUAL(8),sched)) != Normal)
     goto ch_raise_exception;
/* copy 22 13 */
  if((ch_returncode = cp_table(& ch_val, REF(13).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(22).tsdr)->finalize)(REF(22).value,F_DISCARD,sched);
  REF(22).value = ch_val;
  REF(22).tsdr = & dr_table;
/* enum_lit 23 , 0 */
  REF(23).value.enumeration = 0;
  REF(23).tsdr = & dr_enumeration;
  current->ip = 16;
cb38:
/* call 7.3 22 23 24 , 9 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(7)DOT(3),
          arguments[1] = DEF(22),
          arguments[2] = DEF(23),
          arguments[3] = DEF(24),
          arguments[3+1] = nil,& arguments[0]),QUAL(9),sched)) != Normal)
     goto ch_raise_exception;
  return;
c39:
/* noop */
  
/* block , 10 */
  if((ch_returncode = che_block(QUAL(10),sched)) != Normal)
     goto ch_raise_exception;
c47:
c41:
/* discard 25 */
  (*(REF(25).tsdr)->finalize)(REF(25).value,F_DISCARD,sched);
  REF(25).tsdr = & dr_bottom;
/* ilit 26 , 100 */
  REF(26).value.integer = 100;
  REF(26).tsdr = & dr_integer;
  current->ip = 19;
cb45:
/* call 24.3 26 25 , 11 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(24)DOT(3),
          arguments[1] = DEF(26),
          arguments[2] = DEF(25),
          arguments[2+1] = nil,& arguments[0]),QUAL(11),sched)) != Normal)
     goto ch_raise_exception;
  return;
c46:
/* call 11.1 25 , 7 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(11)DOT(1),
          arguments[1] = DEF(25),
          arguments[1+1] = nil,& arguments[0]),QUAL(7),sched)) != Normal)
     goto ch_raise_exception;
  return;
c48:
/* endblock */
  che_endblock(sched);
/* branch , 51 */
   goto c51;
c50:
  current->ip = 23;
cb50:
/* call 24.10 , 12 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(24)DOT(10),
          arguments[0+1] = nil,& arguments[0]),QUAL(12),sched)) != Normal)
     goto ch_raise_exception;
  return;
c51:
/* endblock */
  che_endblock(sched);
c53:
/* discard 24 */
  (*(REF(24).tsdr)->finalize)(REF(24).value,F_DISCARD,sched);
  REF(24).tsdr = & dr_bottom;
c54:
/* discard 20 */
  (*(REF(20).tsdr)->finalize)(REF(20).value,F_DISCARD,sched);
  REF(20).tsdr = & dr_bottom;
/* discard 17 */
  (*(REF(17).tsdr)->finalize)(REF(17).value,F_DISCARD,sched);
  REF(17).tsdr = & dr_bottom;
/* discard 18 */
  (*(REF(18).tsdr)->finalize)(REF(18).value,F_DISCARD,sched);
  REF(18).tsdr = & dr_bottom;
/* discard 22 */
  (*(REF(22).tsdr)->finalize)(REF(22).value,F_DISCARD,sched);
  REF(22).tsdr = & dr_bottom;
/* branch , 12 */
   goto c12;
c59:
/* endget 13 12 */
  end_selector(DEF(13),DEF(12),sched,GET);
/* discard 12 */
  (*(REF(12).tsdr)->finalize)(REF(12).value,F_DISCARD,sched);
  REF(12).tsdr = & dr_bottom;
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c64:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
